#ifndef TRXRND_H
#define TRXRND_H
/*
   Definitions for random number generation

   Copyright  1992-2000 M.Kraemer, GSI Darmstadt, all rights reserved

   $Log: trxrnd.h,v $
   Revision 1.1  2001/01/09 14:54:38  kraemer
   *** empty log message ***


*/

#include "cmderr.h"
#include "m.h"
                                      /* */
union UNQUAD {
#if defined(AMIGA)
   unsigned long ul[2];
#else
   unsigned long long uq;
#endif
   unsigned long ulDummy[2];
};
                                      /* */
#if defined(AMIGA)

#define TRXRNDVRNSD( psRnd, dFac, dAdd, nn, pdRN )\
   if ( (psRnd) -> ulFlag & TRXRND_LECUYER ) {\
      vrnesd( (psRnd)->ulSeedLEcuyer+0, (psRnd)->ulSeedLEcuyer+1, dFac, dAdd, nn, pdRN );\
      {\
      ULONGLONG ull;\
      ull[0] = 0; ull[1] = nn;\
      addq( (psRnd)->unCountLEcuyer.ul, ull );\
      }\
   } else {\
      vrnsd( &((psRnd)->ulSeedprn), dFac, dAdd, nn, pdRN );\
      (psRnd)->ulCountprn += nn;\
   }

#else   

#define TRXRNDVRNSD( psRnd, dFac, dAdd, nn, pdRN)\
   if ( (psRnd) -> ulFlag & TRXRND_LECUYER ) {\
      vrnesd( (psRnd)->ulSeedLEcuyer+0, (psRnd)->ulSeedLEcuyer+1, dFac, dAdd, nn, pdRN );\
      (psRnd)->unCountLEcuyer.uq += nn;\
   } else {\
      vrnsd( &((psRnd)->ulSeedprn), dFac, dAdd, nn, pdRN );\
      (psRnd)->ulCountprn += nn;\
   }
   
#endif
                                      /*  */
struct STRXRND {
   unsigned long ulEvents;            /* # of events to sample */
   unsigned long ulFlag;              /* flag bits (see below) */
   unsigned long ulSeedprn;           /* seed for prn */
   unsigned long ulCountprn;          /* counter for prn algor. */
   unsigned long ulSeedLEcuyer[2];    /* seeds for L'Ecuyer */
   union UNQUAD  unCountLEcuyer;      /* 64-bit counter */
   struct SCMDERR sCE;
};
                                      /* enums */
/*
enum {
};
*/
                                      /* flags */
#define TRXRND_LECUYER 0x00000001
                                      /* */
                                      /* global flags */
#define TRXRND_DEBUG  0x80000000      /* general check flag */
#define TRXRND_QUIET  0x10000000      /* suppress error messages */
#define TRXRND_NOMSG  TRXRND_QUIET

                                      /* */
/*
   --- function prototypes
*/
int TRXRndFree       ( struct STRXRND *, unsigned long );
int TRXRndInit       ( struct STRXRND *, unsigned long );
int TRXRndInspect    ( struct STRXRND *, unsigned long );
int TRXRndIsValid    ( struct STRXRND *, unsigned long );
int TRXRndList       ( struct STRXRND *, unsigned long );
int TRXRndSeedExport ( struct STRXRND *, unsigned long [2], unsigned long );
int TRXRndSeedForward( struct STRXRND *, unsigned long    , unsigned long );
int TRXRndSeedImport ( struct STRXRND *, unsigned long [2], unsigned long );
int TRXRndvrnsd      ( struct STRXRND *, double, double, int, double *, unsigned long );
int TRXRndvpoissond  ( struct STRXRND *, double, int, double *, unsigned long );

struct STRXRND *_TRXRndTest( unsigned long );
 
                                      /* error handling */
int TRXRndError      ( struct SCMDERR *, unsigned long );

enum { ERRTRXRND_SYS=1,
       ERRTRXRND_BADADDR,
       ERRTRXRND_BADNEVENTS,
       ERRTRXRND_BADNUM,
};

#endif

